using System;
using Sce.PlayStation.Core;
using Sce.PlayStation.Core.Graphics;
using Sce.PlayStation.Core.Audio;
using Sce.PlayStation.HighLevel.GameEngine2D;
using Sce.PlayStation.HighLevel.GameEngine2D.Base;
using Sce.PlayStation.Core.Input;

namespace StreetDreams
{
	public class Car : Node
	{
	    private const string carSpriteSheetPath = "Application/assets/images/impreza.png";
		private const string carSpriteSheetXMLPath = "Application/assets/images/impreza.xml";
		private Sce.PlayStation.HighLevel.GameEngine2D.SpriteTile sprite;
		private SpriteSheetHandler spriteSheetHandler;
		private int animationLocation;
		private System.Diagnostics.Stopwatch timer;
		public float speed, acceleration, force, mass;
		public Car(float xPos, float yPos) : base()
		{
			this.speed = 0;
			this.acceleration = 0;
			this.animationLocation = 0;
			spriteSheetHandler = new SpriteSheetHandler(carSpriteSheetPath,carSpriteSheetXMLPath,5,1,175,56);
			sprite = spriteSheetHandler.Get(animationLocation,0);
			float pivotCenter = 0.5f;
			sprite.Pivot = new Vector2(pivotCenter,pivotCenter);
			sprite.Position = new Vector2(xPos,yPos);
			this.AddChild(sprite);
			timer = new System.Diagnostics.Stopwatch();
			timer.Start();
		}
		
		public void accelerate()
		{
			if(acceleration < 5)
			{
				this.acceleration = this.acceleration+1.0f*0.007f;
			}
		}
		
		public void decelerate()
		{
			this.acceleration = this.acceleration-0.5f*0.1f;
		}
		
		public override void Update(float dt)
		{
			base.Update(dt);
			speed+=acceleration;
			if(speed > 400)
			{
				speed = 400;
			}
			if(speed <= 0)
			{
				speed = 0.0f;
				acceleration = 0.0f;
			}
			else
			{
				animationLocation = (animationLocation+1)%5;
				if(timer.ElapsedMilliseconds > 500/speed)
				{
					sprite.TileIndex2D = spriteSheetHandler.Get(animationLocation,0).TileIndex2D;
					timer.Reset();
					timer.Start();
				}
			}
			System.Console.WriteLine("Speed: " + speed);
			this.Position = new Vector2(this.Position.X+speed, this.Position.Y);
		}
	}
}

